<template>
	<v-card :flat="flat">
		<v-container class="pa-5">
			<v-row>
				<v-card v-if="title" flat class="transparent">
					<v-card-title class="text--secondary">{{ title }}</v-card-title>
				</v-card>

				<v-spacer></v-spacer>

				<v-col class="text-right">
					<slot name="buttons"></slot>
				</v-col>
			</v-row>

			<v-row v-if="searchable">
				<v-col>
					<v-text-field
						v-model="search"
						:label="searchLabel"
                        prepend-inner-icon="mdi-magnify"
						@input="performSearch"
						outlined
						hide-details
						clearable
					>
					</v-text-field>
				</v-col>
			</v-row>

			<v-row v-if="isFilterEnabled">
				<v-col>
					<v-menu
						v-model="menu"
						:close-on-content-click="false"
						:nudge-width="200"
						:max-height="400"
						offset-y
						bottom
						eager
						allow-overflow
					>
						<template v-slot:activator="{ on, attrs }">
							<v-btn
								color="primary"
								dark
								v-bind="attrs"
								v-on="on"
							>
								<v-icon left>mdi-filter</v-icon>
								{{ $t('filter') }}
							</v-btn>
						</template>

						<slot
							name="filters"
							:filters="filters"
							:confirmed="applyFilter"
						></slot>
					</v-menu>
				</v-col>
			</v-row>

			<v-row>
				<v-col>
					<v-data-table
						:headers="headers"
						:items="localItems"
						:options.sync="options"
						:item-key="itemKey"
						:server-items-length="total"
						:single-expand="true"
						:loading="loading"
						:loading-text="$t('loading')"
						:disable-pagination="loading"
					>
						<template v-slot:item="{ item, expand, isExpanded }">
							<template v-if="expandable">
								<tr @click="expand(!isExpanded)">
									<slot name="item" :item="item"></slot>
								</tr>
							</template>
							<template v-else>
								<slot name="item" :item="item"></slot>
							</template>
						</template>

						<template v-slot:no-data>
							{{ $t("no_data") }}
						</template>

						<template v-slot:no-results>
							{{ $t("no_result") }}
						</template>

						<template v-slot:expanded-item="{ headers, item }">
							<slot
								name="expanded-item"
								:headers="headers"
								:item="item"
							>
							</slot>
						</template>
					</v-data-table>
				</v-col>
			</v-row>
		</v-container>
	</v-card>
</template>

<script>
export default {
	name: "DataTable",
	props: {
		endpoint: String,
		title: {
			type: String,
			default: ""
		},
		headers: Array,
		filters: Object,
		searchable: {
			type: Boolean,
			default: true
		},
		searchLabel: {
			type: String,
			default: ""
		},
		itemKey: {
			type: String,
			default: "id"
		},
		value: {
			type: Array,
			required: true
		},
		expandable: {
			type: Boolean,
			default: false
		},
		flat: {
			type: Boolean,
			default: false
		},
		forceFetch: {
			type: Boolean,
			default: false
		}
	},

	data: () => ({
		search: "",
		total: 0,
		options: {},
		loading: false,
		menu: false
	}),

	computed: {
		isFilterEnabled() {
			return !_.isEmpty(this.filters);
		},

		localItems: {
			get() {
				return this.value;
			},
			set(val) {
				this.$emit("input", val);
			}
		}
	},

	watch: {
		forceFetch(val) {
			if (val === true) {
				this.getDataFromApi()
					.then(data => {
						this.loading = false;
						this.localItems = data.items;
						this.total = data.total;

						this.$emit("update:forceFetch", false);
					})
					.catch(() => {
						this.loading = false;
					});
			}
		},

		options: {
			handler() {
				this.getDataFromApi()
					.then(data => {
						this.loading = false;
						this.localItems = data.items;
						this.total = data.total;
					})
					.catch(error => {
						this.loading = false;
					});
			},
			deep: true
		}
	},

	methods: {
		applyFilter() {
			this.menu = false;

			this.getDataFromApi()
				.then(data => {
					this.loading = false;
					this.localItems = data.items;
					this.total = data.total;
				})
				.catch(error => {
					this.loading = false;
				});
		},

		getDataFromApi() {
			this.loading = true;

			return new Promise((resolve, reject) => {
				const {sortBy, sortDesc, page, itemsPerPage} = this.options;

				axios
					.get(this.endpoint, {
						params: {
							sortBy: sortBy[0],
							sortDesc: sortDesc[0],
							page: page,
                            per_page: itemsPerPage === -1 ? this.total : itemsPerPage,
							search: this.search ? this.search : undefined,
							filter: this.isFilterEnabled ? this.filters : undefined
						}
					})
					.then(response => {
						let items = response.data.data;
						const total = response.data.meta.total;

						resolve({
							items,
							total
						});
					})
					.catch(error => {
						reject(error.response.data);
					});
			});
		},

		performSearch: _.debounce(function () {
			this.getDataFromApi()
				.then(data => {
					this.loading = false;
					this.localItems = data.items;
					this.total = data.total;
				})
				.catch(error => {
					this.loading = false;
				});
		}, 600)
	}
};
</script>

<style scoped></style>
